/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.gebietsbaum.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="STRASSENEINTRAG.UK",
     query="SELECT o FROM Strasseneintrag o WHERE "

                         + "o"
                +".hausnummernbereich"
              +" = ?1"

             +" AND "         + "o"
                +".postleitzahl"
              +" = ?2"

             +" AND "         + "o"
                +".strassenname"
              +" = ?3"

             +" AND "         + "o"
                +".gebiet"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".name"
              +" = ?5"

             +" AND "         + "o"
                +".gebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?7"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?8"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?10"

             +" AND "         + "o"
                +".gebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?11"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".nummer"
              +" = ?12"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?13"

             +" AND "         + "o"
                +".gebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?14"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?15"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?16"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?17"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?18"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?19"

             +" AND "         + "o"
                +".wahltermin"
                +".nummer"
              +" = ?20"

             +" AND "         + "o"
                +".wahltermin"
                +".wahldatum"
              +" = ?21"

             +" AND "         + "o"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?22"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="STRASSENEINTRAG.WahlCount",
     query="SELECT COUNT(o) FROM Strasseneintrag o WHERE o.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STRASSENEINTRAG.Wahl",
     query="SELECT o FROM Strasseneintrag o WHERE o.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STRASSENEINTRAG.Wahltermin",
     query="SELECT o FROM Strasseneintrag o WHERE o.wahltermin = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "STRASSENEINTRAG")
// @javax.persistence.IdClass(StrasseneintragPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Strasseneintrag
extends AbstractStrasseneintrag
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Strasseneintrag() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Strasseneintrag(Strasseneintrag original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "strasseneintrag_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Strasseneintrag")
    @javax.persistence.TableGenerator(name = "Strasseneintrag", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Strasseneintrag", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient StrasseneintragPK pkCache;

  @Override
  public StrasseneintragPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new StrasseneintragPK(getId());
    }

    return pkCache;
  }

  public static <E extends Strasseneintrag> java.util.Map<StrasseneintragPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<StrasseneintragPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Strasseneintrag> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedHausnummernbereich = false;
          hasChangedPostleitzahl = false;
          hasChangedStrassenname = false;
  
      hasChangedGebiet = false;
        hasChangedWahltermin = false;
        hasChangedWahl = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "HAUSNUMMERNBEREICH", nullable = StrasseneintragConstants.HAUSNUMMERNBEREICH_NULLABLE, length=StrasseneintragConstants.HAUSNUMMERNBEREICH_MAX_LENGTH)
        
  protected java.lang.String hausnummernbereich =  null;

  @javax.persistence.Transient
  protected boolean hasChangedHausnummernbereich = false;

  public boolean hasChangedHausnummernbereich(){
    return hasChangedHausnummernbereich;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertHausnummernbereich = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenHausnummernbereich;
  
  /**
   * 
   *
   * getter for STRASSENEINTRAG.HAUSNUMMERNBEREICH
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getHausnummernbereich() {
        return hausnummernbereich;
      }

  /**
   * 
   *
   * setter for STRASSENEINTRAG.HAUSNUMMERNBEREICH
   *
   * @param hausnummernbereich
   */
  @Override   public void setHausnummernbereich(@javax.annotation.Nullable  java.lang.String hausnummernbereich) {

       resetTkCache();
                  
                          java.lang.String hausnummernbereichInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(hausnummernbereich, StrasseneintragConstants.HAUSNUMMERNBEREICH_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.hausnummernbereich
      , hausnummernbereichInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedHausnummernbereich |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("hausnummernbereich");
      }


             if (!isSeitLadenVeraendertHausnummernbereich) {
          isSeitLadenVeraendertHausnummernbereich = thisAttributChanged;
         if (isSeitLadenVeraendertHausnummernbereich){
           wertNachLadenHausnummernbereich=this.hausnummernbereich;
         }
       }
      

       this.hausnummernbereich = hausnummernbereichInternal;

         }

        
  @javax.persistence.Column(name = "POSTLEITZAHL", nullable = StrasseneintragConstants.POSTLEITZAHL_NULLABLE, length=StrasseneintragConstants.POSTLEITZAHL_MAX_LENGTH)
        
  protected java.lang.String postleitzahl =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPostleitzahl = false;

  public boolean hasChangedPostleitzahl(){
    return hasChangedPostleitzahl;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertPostleitzahl = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenPostleitzahl;
  
  /**
   * 
   *
   * getter for STRASSENEINTRAG.POSTLEITZAHL
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getPostleitzahl() {
        return postleitzahl;
      }

  /**
   * 
   *
   * setter for STRASSENEINTRAG.POSTLEITZAHL
   *
   * @param postleitzahl
   */
  @Override   public void setPostleitzahl(@javax.annotation.Nullable  java.lang.String postleitzahl) {

       resetTkCache();
                  
                          java.lang.String postleitzahlInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(postleitzahl, StrasseneintragConstants.POSTLEITZAHL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.postleitzahl
      , postleitzahlInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPostleitzahl |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("postleitzahl");
      }


             if (!isSeitLadenVeraendertPostleitzahl) {
          isSeitLadenVeraendertPostleitzahl = thisAttributChanged;
         if (isSeitLadenVeraendertPostleitzahl){
           wertNachLadenPostleitzahl=this.postleitzahl;
         }
       }
      

       this.postleitzahl = postleitzahlInternal;

         }

        
      @javax.persistence.Column(name = "STRASSENNAME", nullable = StrasseneintragConstants.STRASSENNAME_NULLABLE, length=StrasseneintragConstants.STRASSENNAME_MAX_LENGTH)
        
  protected java.lang.String strassenname =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStrassenname = false;

  public boolean hasChangedStrassenname(){
    return hasChangedStrassenname;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStrassenname = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenStrassenname;
  
  /**
   * 
   *
   * getter for STRASSENEINTRAG.STRASSENNAME
   */
    @Override   public  java.lang.String getStrassenname() {
        return strassenname;
      }

  /**
   * 
   *
   * setter for STRASSENEINTRAG.STRASSENNAME
   *
   * @param strassenname
   */
  @Override   public void setStrassenname( java.lang.String strassenname) {

       resetTkCache();
                  
                          java.lang.String strassennameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(strassenname, StrasseneintragConstants.STRASSENNAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.strassenname
      , strassennameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStrassenname |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("strassenname");
      }


             if (!isSeitLadenVeraendertStrassenname) {
          isSeitLadenVeraendertStrassenname = thisAttributChanged;
         if (isSeitLadenVeraendertStrassenname){
           wertNachLadenStrassenname=this.strassenname;
         }
       }
      

       this.strassenname = strassennameInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Gebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "GEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet;

  /**
   * 
   */
  @Override
  public void setGebiet( de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gebiet
    , gebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedGebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("gebiet");
    }

    this.gebiet = gebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Gebiet getGebiet(){
    return this.gebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedGebiet = false;

  public boolean hasChangedGebiet(){
    return hasChangedGebiet;
  }

  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Strasseneintrag:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Strasseneintrag other){
                             other.hausnummernbereich = this.hausnummernbereich;
                                other.postleitzahl = this.postleitzahl;
                                other.strassenname = this.strassenname;
           
  other.setGebiet(this.getGebiet());
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Strasseneintrag.class)){
        copyEntityAttributesUsingSetter((Strasseneintrag) other.castTo(Strasseneintrag.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Strasseneintrag: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Strasseneintrag other){
               other.setHausnummernbereich(this.hausnummernbereich);
                  other.setPostleitzahl(this.postleitzahl);
                  other.setStrassenname(this.strassenname);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Strasseneintrag other){
                       if (hasChangedHausnummernbereich) {
        other.setHausnummernbereich(this.hausnummernbereich);
      }
                             if (hasChangedPostleitzahl) {
        other.setPostleitzahl(this.postleitzahl);
      }
                             if (hasChangedStrassenname) {
        other.setStrassenname(this.strassenname);
      }
             }





    @javax.persistence.Transient
    private transient StrasseneintragTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public StrasseneintragTK getStrasseneintragTK(){
    if (tkCache==null) {
    tkCache = new StrasseneintragTK(

getHausnummernbereich()
, getPostleitzahl()
, getStrassenname()
,   (getGebiet() == null) ? null : getGebiet().getGebietTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getStrasseneintragTK();
    }

  @Override
  public StrasseneintragUK getUk(){
    return getStrasseneintragUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Strasseneintrag.class;
  }

public StrasseneintragUK getStrasseneintragUK(){

   return  new StrasseneintragUK(

getHausnummernbereich()
, getPostleitzahl()
, getStrassenname()
,     getGebiet()==null?null:getGebiet().getGebietUK()
,     getWahl()==null?null:getWahl().getWahlUK()
,     getWahltermin()==null?null:getWahltermin().getWahlterminUK()


  );
}

  @javax.persistence.Transient
  private transient StrasseneintragProperties properties;

  public StrasseneintragProperties getProperties(){
    if (properties == null) {
      properties = new StrasseneintragProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public StrasseneintragProperties getStrasseneintragProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return StrasseneintragConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(StrasseneintragConstants.MESSAGE_KEY_HAUSNUMMERNBEREICH_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StrasseneintragConstants.MESSAGE_KEY_HAUSNUMMERNBEREICH_EINZAHL);

        hausnummernbereich =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StrasseneintragConstants.MESSAGE_KEY_POSTLEITZAHL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StrasseneintragConstants.MESSAGE_KEY_POSTLEITZAHL_EINZAHL);

        postleitzahl =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StrasseneintragConstants.MESSAGE_KEY_STRASSENNAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StrasseneintragConstants.MESSAGE_KEY_STRASSENNAME_EINZAHL);

        strassenname =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertHausnummernbereich) {
      result.put(StrasseneintragConstants.MESSAGE_KEY_HAUSNUMMERNBEREICH_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenHausnummernbereich , hausnummernbereich));
    }
                            if (isSeitLadenVeraendertPostleitzahl) {
      result.put(StrasseneintragConstants.MESSAGE_KEY_POSTLEITZAHL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenPostleitzahl , postleitzahl));
    }
                            if (isSeitLadenVeraendertStrassenname) {
      result.put(StrasseneintragConstants.MESSAGE_KEY_STRASSENNAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenStrassenname , strassenname));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertHausnummernbereich = false;
      wertNachLadenHausnummernbereich = null;
                          isSeitLadenVeraendertPostleitzahl = false;
      wertNachLadenPostleitzahl = null;
                          isSeitLadenVeraendertStrassenname = false;
      wertNachLadenStrassenname = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "STRASSENEINTRAG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Strasseneintrag";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StrasseneintragConstants.HAUSNUMMERNBEREICH_MAX_LENGTH ,  hausnummernbereich, this, StrasseneintragConstants.MESSAGE_KEY_HAUSNUMMERNBEREICH_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StrasseneintragConstants.POSTLEITZAHL_MAX_LENGTH ,  postleitzahl, this, StrasseneintragConstants.MESSAGE_KEY_POSTLEITZAHL_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(strassenname, this, StrasseneintragConstants.MESSAGE_KEY_STRASSENNAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StrasseneintragConstants.STRASSENNAME_MAX_LENGTH , 1 ,  strassenname, this, StrasseneintragConstants.MESSAGE_KEY_STRASSENNAME_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
